import { StoreOptions, ActionHandler, ActionObject } from 'vuex';
declare type AnyFunction = (...a: any) => any;
export declare type Payload<T extends AnyFunction> = T extends (...arg: [any, ...infer P]) => any ? P : never;
declare type GetPayloadAndChangeReturn<T extends AnyFunction, NewReturn> = (...arg: Payload<T>) => NewReturn;
export declare type PromiseAction<T> = T extends ActionHandler<any, any> ? GetPayloadAndChangeReturn<T, Promise<ReturnType<T>>> : T extends ActionObject<any, any> ? GetPayloadAndChangeReturn<T['handler'], Promise<ReturnType<T['handler']>>> : never;
export declare type PayloadAction<T> = T extends ActionHandler<any, any> ? Payload<T> : T extends ActionObject<any, any> ? Payload<T['handler']> : never;
export declare type Mutation<T extends (...args: any[]) => void> = GetPayloadAndChangeReturn<T, void>;
export declare type Module<T extends StoreOptions<any>> = T['modules'];
export declare type Getters<T extends StoreOptions<any>> = T['getters'];
export declare type Actions<T extends StoreOptions<any>> = T['actions'];
export declare type State<T extends StoreOptions<any>> = T['state'];
export declare type Mutations<T extends StoreOptions<any>> = T['mutations'];
export declare type OnlyString<T> = keyof T & string;
export declare type GetNameSpaceKeys<T extends StoreOptions<any>, E, K> = E extends OnlyString<Module<T>> ? K extends OnlyString<Module<T>[E]> ? OnlyString<Module<T>[E][K]> : never : never;
export declare type GetNameSpaceObject<T extends StoreOptions<any>, E, K> = E extends OnlyString<Module<T>> ? K extends OnlyString<Module<T>[E]> ? Module<T>[E][K] : never : never;
export {};
